/* Copyright (C) 1995 by Joseph J. Pfeiffer, Jr.
Use, redistribution, and modification of this code is permitted without
fee subject to the following conditions:

1.  Redistribution of this code must preserve this copyright notice.

2.  Binary distributions must include this notice and disclaimer.

3.  Advertising materials that refer to specific features of this
    product must acknowledge the author.

4.  The author's name may not be used to endorse or promote any
    product derived from this software without written permission.
*/
/* this is a little utility to generate pen calibration parameters for use
   with X.  */
#include <fcntl.h>
#define BUFLEN 5

main() {
    unsigned char penbuf[BUFLEN];
    int fd;
    short xmin, xmax, ymin, ymax;
    float xscale, yscale;

    fd = open("/dev/cpqpen", O_RDONLY);
    printf("fd = %d\r", fd);
    if (fd < 0) {
        perror("open failed");
        exit(-1);
    }

    printf("Put the pen against the screen in the upper left corner\n");
    printf("of the display and press the barrel button\n");

    do {
        if (read(fd, penbuf, BUFLEN) != BUFLEN) {
            perror("bad pen read");
            exit(-2);
        }
    } while ((penbuf[0] & 0x3) != 0x3);

    xmin = (penbuf[1] << 8) | (penbuf[2] & 0xff);
    ymin = (penbuf[3] << 8) | (penbuf[4] & 0xff);

    printf("upper left corner pen coordinates are (%d, %d)\n\n", xmin, ymin);

    do {
        if (read(fd, penbuf, BUFLEN) != BUFLEN) {
            perror("bad pen read");
            exit(-2);
        }
    } while (penbuf[0] & 0x3);

    printf("Put the pen against the screen in the lower right corner\n");
    printf("of the display and press the barrel button\n");

    do {
        if (read(fd, penbuf, BUFLEN) != BUFLEN) {
            perror("bad pen read");
            exit(-2);
        }
    } while ((penbuf[0] & 0x3) != 0x3);

    xmax = (penbuf[1] << 8) | (penbuf[2] & 0xff);
    ymax = (penbuf[3] << 8) | (penbuf[4] & 0xff);

    printf("lower right corner pen coordinates are (%d, %d)\n\n", xmax, ymax);

    xscale = 640.0 / (xmax - xmin);
    yscale = 480.0 / (ymax - ymin);

    printf("replace the pointer protocol line in XF86Config with:\n");
    printf("    Protocol     \"Pencpq\"  %d %f %d %f\n",
           xmin, xscale, ymin, yscale);
}

    
